package net.crystalyx.fxpix;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.widget.Toast;

import java.net.MalformedURLException;
import java.net.URL;

public class MainActivity extends Activity {
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        Intent intent = getIntent();
        String type = intent.getType();

        if (Intent.ACTION_SEND.equals(intent.getAction()) && "text/plain".equals(type)) {
            URL originalUrl;
            URL fixedUrl;

            try {
                originalUrl = new URL(intent.getStringExtra(Intent.EXTRA_TEXT));

                switch (originalUrl.getHost()) {
                    case "twitter.com":
                    case "t.co":
                    case "x.com":
                        fixedUrl = new URL(originalUrl.getProtocol(), "nitter.net", originalUrl.getPort(), originalUrl.getFile());
                        break;
                    case "pixiv.net":
                    case "www.pixiv.net":
                        fixedUrl = new URL(originalUrl.getProtocol(), "www.ppxiv.net", originalUrl.getPort(), originalUrl.getFile());
                        break;
                    default:
                        fixedUrl = originalUrl;
                        break;
                }

                Intent sharingIntent = new Intent(Intent.ACTION_SEND);
                sharingIntent.setType("text/plain");
                sharingIntent.putExtra(Intent.EXTRA_TEXT, fixedUrl.toString());
                startActivity(Intent.createChooser(sharingIntent, "Share via"));
            } catch (MalformedURLException e) {
                Toast.makeText(this, e.getMessage(), Toast.LENGTH_SHORT).show();
                return;
            }
        }

        finish();
    }
}
